{                          MSILOW.INC
                           MSINST 4.0
             Copyright (c) 1985, 87 by Borland International, Inc.            }

  procedure RestoreScreen;
    {-Clean up screen at end of program}

  begin                       {RestoreScreen}
    NormVideo;
    ClrScr;
  end;                        {RestoreScreen}

  function FileExists(name : Varstring; var f : file) : Boolean;
    {-return true and an open file if file exists}
  begin
    Assign(f, name);
    Reset(f, 1);
    FileExists := (IOResult = 0);
  end;                        {fileexists}

  procedure StUpcase(var s : Varstring);
    {-uppercase the string}
  var
    i : Byte;
  begin
    for i := 1 to Length(s) do
      s[i] := UpCase(s[i]);
  end;                        {Stupcase}

  procedure SetColor(thecolor : Byte);
    {-set both textcolor and textbackground}
  begin
    TextColor(thecolor and $F);
    TextBackground(thecolor shr 4);
  end;                        {SetColor}

  function GetCursorCommand : Char;
    {-return cursor equivalent keys}
  var
    ch : Char;
    good : Boolean;
  begin
    repeat
      Read(Kbd, ch);
      if (ch = #27) and KeyPressed then begin
        Read(Kbd, ch);
        case ch of
          #75 : ch := ^S;
          #77 : ch := ^D;
          #72 : ch := ^E;
          #80 : ch := ^X;
          #71 : ch := ^T;
          #73 : ch := ^R;
          #81 : ch := ^C;
          #79 : ch := ^B;
        end;
      end else
        ch := UpCase(ch);
      good := (ch in [^R, ^C, ^E, ^X, ^W, ^Z, ^A, ^S, ^D, ^F, ^M, 'Q', ^T, ^B]);
    until good;
    GetCursorCommand := ch;
  end;                        {GetCursorCommand}

  function Getkey(prompt, choices : Varstring) : Char;
    {-return a legal menu choice}
  var
    ch : Char;
  begin
    Write(prompt);
    repeat
      Read(Kbd, ch);
      ch := UpCase(ch);
    until Pos(ch, choices) <> 0;
    Getkey := ch;
  end;                        {GetKey}

  function YesNo(prompt, default : Varstring) : Boolean;
    {-return True for yes, False for no}
  var
    ch : Char;
  begin
    Write(prompt);
    Write(' (Y/N/<Enter> for ', default, ') ');
    repeat
      Read(Kbd, ch);
      if ch = ^M then ch := default;
      ch := UpCase(ch);
    until (ch in ['Y', 'N']);
    WriteLn(ch);
    YesNo := (ch = 'Y');
  end;                        {YesNo}

  procedure GetScreenMode;
  begin
    {Determine screen type for screen updating procedure}
    Reg.ax := $0F00;
    {BIOS INT 10H call to get screen type}
    Intr($10, Reg);
    WaitForRetrace := (Reg.al <> 7);
    if WaitForRetrace then begin
      {Color card}
      BaseOfScreen := $B800;
      LoColor := $1E;
      TiColor := $1A;
      ChColor := $1F;
      EdColor := $7F;
      CfColor := $4A;
    end else begin
      BaseOfScreen := $B000;
      LoColor := $07;
      TiColor := $0F;
      ChColor := $0F;
      EdColor := $70;
      CfColor := $70;
    end;
  end;

  procedure FastWrite(St : Varstring; Row, Col, Attr : Byte);
  begin
    inline(
      $1E/$8B/$7E/< Row/$4F/$B9/$04/$00/$D3/$E7/$89/$F8/$D1/$E7/$D1/$E7/
      $01/$C7/$8B/$46/< Col/$48/$01/$C7/$D1/$E7/$8D/$76/< St/$8B/$16/
      > BaseOfScreen/$8E/$C2/$A0/> WaitForRetrace/$8C/$D2/$8E/$DA/$8A/
      $0C/$E3/$2B/$46/$8A/$66/< Attr/$FC/$D0/$D8/$73/$1E/$BA/$DA/$03/
      $AC/$89/$C3/$FA/$EC/$A8/$08/$75/$09/$D0/$D8/$72/$F7/$EC/$D0/$D8/
      $73/$FB/$89/$D8/$AB/$FB/$E2/$E8/$E9/$04/$00/$AC/$AB/$E2/$FC/$1F
      );
  end;

  procedure FastWriteV(var St : Varstring; Row, Col, Attr : Byte);
  begin
    inline(
      $1E/$8B/$46/< Row/$48/$B9/$04/$00/$D3/$E0/$89/$C3/$D1/$E0
      /$D1/$E0/$01/$D8/$8B/$5E/< Col/$4B/$01/$D8/$D1/$E0/$89/$C7
      /$8B/$16/> BaseOfScreen/$8E/$C2/$A0/> WaitForRetrace/$C5
      /$76/< St/$8A/$0C/$E3/$2B/$46/$8A/$66/< Attr/$FC/$D0/$D8
      /$73/$1E/$BA/$DA/$03/$AC/$89/$C3/$FA/$EC/$A8/$08/$75/$09
      /$D0/$D8/$72/$F7/$EC/$D0/$D8/$73/$FB/$89/$D8/$AB/$FB/$E2
      /$E8/$E9/$04/$00/$AC/$AB/$E2/$FC/$1F
      );
  end;

  procedure ClrEol(Col, Row, Attr : Integer);
    {-clear to end of line}
  begin
    BlankLine[0] := Chr(81-Col);
    FastWriteV(BlankLine, Row, Col, Attr);
  end;

  procedure Center(Row, Attr : Byte; prompt : Varstring);
    {-write the prompt centered on row with attribute attr}
  var
    len : Byte absolute prompt;
  begin
    ClrEol(1, Row, Attr);
    FastWriteV(prompt, Row, 41-(len shr 1), Attr);
  end;                        {Center}

  function CenterPad(s : Varstring; padch : Char; width : Byte) : Varstring;
    {-pad s on both sides with padch to total size width}
  var
    t : Varstring;
  begin
    if Length(s) >= width then
      CenterPad := s
    else begin
      FillChar(t[1], width, padch);
      t[0] := Chr(width);
      Move(s[1], t[1+((width-Length(s)) shr 1)], Length(s));
      CenterPad := t;
    end;
  end;                        {CenterPad}

  function Pad(s : Varstring; w : Byte) : Varstring;
    {-return a string right padded with blanks to width w}
  var
    len : Byte absolute s;
  begin
    while len < w do
      s := s+' ';
    Pad := s;
  end;                        {pad}

  function TextRepresentation(k : keyrec) : Varstring;
    {-return a text representation of the keys}
  var
    p, len : Byte;
    ch : Char;
    dis : Varstring;

    function EscapeSequence(oCh : Byte) : Varstring;
      {-Return the text representation of an extended ASCII sequence}

    begin                     {EscapeSequence}
      EscapeSequence := '<'+escs[Chr(oCh)]+'>';
    end;                      {EscapeSequence}

  begin                       {TextRepresentation}
    with k do begin
      p := 1;
      len := Length(keys);
      dis := '';
      while p <= len do begin
        ch := keys[p];
        if (ch = #0) then begin
          if (p = len) then
            {a lone null, where did it come from}
            dis := dis+'<Null>'
          else begin
            {an escape sequence}
            p := Succ(p);
            dis := dis+EscapeSequence(Ord(keys[p]));
          end;
        end else if (ch = #27) then
          dis := dis+'<Esc>'
        else if (ch < ' ') then
          {a control char}
          dis := dis+'<Ctrl'+Chr(Ord(ch)+64)+'>'
        else if (ch = #127) then
          {ctrl-backspace = ASCII DEL}
          dis := dis+'<CtrlBks>'
        else
          {a normal character - shouldn't be any used as commands}
          dis := dis+ch;
        p := Succ(p);
      end;
    end;
    TextRepresentation := dis;
  end;                        {TextRepresentation}

  procedure HaltError(msg : Varstring);
    {-Display an error message and halt}

  begin                       {HaltError}
    RestoreScreen;
    WriteLn;
    WriteLn(msg);
    Halt(1);
  end;                        {HaltError}

  procedure Error(ErrNo, ErrAddr : Integer);
    {-errors interrupt to this procedure, not to be called directly}
  begin
    if Hi(ErrNo) = 0 then begin
      {^C, just exit without an address printed}
      WriteLn('^C');
      Halt(1);
    end;
  end;                        {error}

  procedure Initialize;
    {-Set up for installation}

  begin                       {Initialize}
    ClrScr;

    {set up break handler}
    errorptr := Ofs(Error);
    GetScreenMode;
    SetColor(LoColor);
    biosbuf := #0;

    {initialize a blank line}
    FillChar(BlankLine[1], 80, #32);

  end;                        {Initialize}

  function EdBiosKeyPressed : Boolean;
    {-Return true if a key is available}
  var
    Result : Boolean;

  begin                       {EdBiosKeyPressed}
    if biosbuf = #0 then begin
      {No previously buffered code available}
      inline(
        $B4/$01/              {MOV  AH,1}
        $30/$DB/              {XOR  BL,BL}
        $CD/$16/              {INT  16H}
        $74/$02/              {JZ   store}
        $FE/$C3/              {INC  BL}
        {store:}
        $88/$5E/< Result      {MOV  Result[BP],BL}
        );
      EdBiosKeyPressed := Result;
    end else
      {A previously buffered extended scan code is available}
      EdBiosKeyPressed := True;
  end;                        {EdBiosKeyPressed}

  procedure EdBiosReadKbd(var ch : Char);
    {-read via BIOS, with extended scan support}
  var
    Code : Integer;

  begin                       {EdBiosReadKbd}
    if biosbuf = #0 then begin
      {No previously buffered code available}
      inline(
        $30/$E4/              {xor  ah,ah}
        $CD/$16/              {int  16H}
        $89/$46/< Code        {mov  <Code[bp],ax}
        );
      if Lo(Code) = 0 then begin
        {Extended character - return #0 and buffer the scan code}
        ch := #0;
        biosbuf := Chr(Hi(Code));
      end else
        {Normal character}
        ch := Chr(Lo(Code));
    end else begin
      {A previous extended scan code available}
      ch := biosbuf;
      biosbuf := #0;
    end;
  end;                        {EdBiosReadKbd}

